program bench;
uses dos,sysutils;
var S:array[0..255] of integer;
    S64K:array[0..65535] of integer;
    S1M:array[0..1048575] of integer;
    md1,md2:array[0..33554431] of integer;
    i,j,multi,max_i,a,b,t1,t2,speed,time_begin,time_end,time_elapsed,l,test_size,q1,q2,q3,q4,q5,q6:integer;
    speed1,speed2,speed3,speed4,speed5,speed6,speed7,speed8,speed9,speed10,speed11,speed12,speed13:integer;
    speed1eq,speed2eq,speed3eq,speed4eq,speed5eq,speed6eq,speed7eq,speed8eq,speed9eq,speed10eq,speed11eq,speed12eq,speed13eq:integer;
    eq1,eq2,eq3,eq4,eq5,eq6,eq7,eq8,eq9,eq10,eq11,eq12,eq13:integer;
    s_overall,c_overall,m_overall:integer;
    rq1,rq2,rq3:real;
    ts:ttimestamp;
    processor:string;
    auto_mode:char;
    custom_system:text;

procedure p4_equiv;
begin
processor:='P4';
eq1:=37;           //arc4
eq2:=64;           //conditional
eq3:=49;           //arc4/16
eq4:=688;          //arc4 1M
eq5:=40;           //int
eq6:=76;           //slow int
eq7:=57;           //fp
eq8:=2980;         //slow fp
eq9:=597;          //move 1 KB
eq10:=335;         //move 32 KB
eq11:=6029;        //move 1 MB
eq12:=6098;        //move 16 MB
eq13:=6470;        //move 64 MB
end;

procedure p3_equiv;
begin
processor:='P3';
eq1:=33;           //arc4
eq2:=80;           //conditional
eq3:=88;           //arc4/16
eq4:=296;          //arc4 1M
eq5:=49;           //int
eq6:=100;          //slow int
eq7:=44;           //fp
eq8:=398;          //slow fp
eq9:=413;          //move 1 KB
eq10:=491;         //move 32 KB
eq11:=6656;        //move 1 MB
eq12:=6680;        //move 16 MB
eq13:=7068;        //move 64 MB
end;

procedure k7xp_m_equiv;
begin
processor:='K7XP-M';
eq1:=34;           //arc4
eq2:=69;           //conditional
eq3:=59;           //arc4/16
eq4:=611;          //arc4 1M
eq5:=47;           //int
eq6:=105;          //slow int
eq7:=33;           //fp
eq8:=747;          //slow fp
eq9:=516;          //move 1 KB
eq10:=360;         //move 32 KB
eq11:=6951;        //move 1 MB
eq12:=6946;        //move 16 MB
eq13:=6995;        //move 64 MB
end;

procedure r_ksa (var S:array of integer);
var i,t:integer;
key:array[0..15] of integer;
begin
   for a:=0 to 255 do S[a]:=a;
   randomize;
   for i:=0 to 15 do key[i]:=random(256);
   for a:=0 to 255 do
      begin
      b:=(b+S[a]+key[a and 15]) and 255;
      t:=S[a];
      S[a]:=S[b];
      S[b]:=t;
      end;
end;

procedure r_ksa_64K (var S64K:array of integer);
var i,t:integer;
key:array[0..15] of integer;
begin
   for a:=0 to 65535 do S64K[a]:=a;
   randomize;
   for i:=0 to 15 do key[i]:=random(65536);
   for a:=0 to 65535 do
      begin
      b:=(b+S[a]+key[a and 15]) and 65535;
      t:=S[a];
      S[a]:=S[b];
      S[b]:=t;
      end;
end;

procedure r_ksa_1M (var S1M:array of integer);
var i,t:integer;
key:array[0..15] of integer;
begin
   for a:=0 to 1048575 do S1M[a]:=a;
   randomize;
   for i:=0 to 15 do key[i]:=random(1048576);
   for a:=0 to 1048575 do
      begin
      b:=(b+S1M[a]+key[a and 15]) and 1048575;
      t:=S1M[a];
      S1M[a]:=S1M[b];
      S1M[b]:=t;
      end;
end;

procedure processor_rating(a: integer);
//load processor rating
begin
case a of
0: begin
   try
   assign(custom_system,'system.txt');
   reset(custom_system);
   readln(custom_system,processor);
   readln(custom_system,eq1);
   readln(custom_system,eq2);
   readln(custom_system,eq3);
   readln(custom_system,eq4);
   readln(custom_system,eq5);
   readln(custom_system,eq6);
   readln(custom_system,eq7);
   readln(custom_system,eq8);
   readln(custom_system,eq9);
   readln(custom_system,eq10);
   readln(custom_system,eq11);
   readln(custom_system,eq12);
   readln(custom_system,eq13);
   close(custom_system);
   except on E : exception do begin p4_equiv; writeln('system.txt not found in the path of the executable, system will be rated as P4');end; end;
   end;
1: p4_equiv;
2: p3_equiv;
3: k7xp_m_equiv;
else p4_equiv;
end;
end;

procedure bench_presentation;
begin
if l < 6000 then
begin
writeln('....:....1....:....2....:....3....:....4....:....5....:....6 GHz ',processor);
repeat
   l:=l-100;
   if l>-1 then write('|')
   else
      if l>-51 then write('|')
      else write(' ');
until l < 0;
writeln;
end
else
begin
writeln('....:....10...:....20...:....30...:....40...:....50...:....60 GHz ',processor);
repeat
   l:=l-1000;
   if l>-1 then write('|')
   else
      if l>-510 then write('|')
      else write(' ');
until l < 0;
writeln;
end;
end;

begin //main
speed1:=0;
speed2:=0;
speed3:=0;
speed4:=0;
speed5:=0;
speed6:=0;
speed7:=0;
speed8:=0;
speed9:=0;
speed10:=0;
speed11:=0;
speed12:=0;
speed13:=0;
q1:=0;
q2:=0;
q3:=0;
q4:=0;
q5:=0;
q6:=0;
rq1:=0;
rq2:=0;
rq3:=0;
test_size:=1024*1024*16;
write('Authomatic mode? (y/n) ');
readln(auto_mode);
if upcase(auto_mode)='N' then
   begin
   repeat
   {$I-}
   write('Times to repeat the tests battery: (1-4) ');
   readln(max_i);
   {$I+}
   until ioresult=0;
   if max_i<1 then max_i:=1;
   if max_i>4 then max_i:=4;
   repeat
   {$I-}
   write('Single test reiterations: (1-16) ');
   readln(multi);
   {$I+}
   until ioresult=0;
   if multi<1 then multi:=1;
   if multi>16 then multi:=16;
   repeat
   {$I-}
   write('Rating: (0 custom, 1 P4, 2 P3, 3 K7XP-M) ');
   readln(a);
   {$I+}
   until ioresult=0;
   end
else
   begin
   max_i:=3;
   multi:=1;
   a:=1;
   end;
processor_rating(a);

//run tests
for i:=1 to max_i do
   begin
   a:=0;
   b:=0;
   write('pass ',i,'/',max_i,' ');

   r_ksa(S);
   //1 arc4 speed
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {3 +, 2 substitution, 3 and operation performed per cycle, obtaining a pr m integer}
      a:=(a+1) and 255;
      b:=(b+S[a]) and 255; {actually with fpc1.9.2 this seem to perform a little better than calculating t1 before b and using it instead of S8[0,a]}
      t1:=S[a];
      t2:=S[b];
      S[a]:=t2;
      S[b]:=t1;
      md1[l]:=S[(t1+t2) and 255];
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed1:=speed1+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md1[a]);

   //2 random conditional
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {conditional: 16 element case of, 4 level nested if..else strongly biased toward 4 then, single level if biased toward then}
      case md1[l] of
      0: q1:=200;
      1: q1:=201;
      2: q1:=202;
      3: q1:=203;
      4: q1:=204;
      5: q1:=205;
      6: q1:=206;
      7: q1:=207;
      8: q1:=208;
      9..12: q1:=209;
      13..20: q1:=210;
      21..36: q1:=211;
      37..68: q1:=212;
      69..132: q1:=213;
      133..232: q1:=214;
      233..242: q1:=215;
      else q1:=255;
      end;
      if md1[l] = 0 then q1:=300
      else
         if md1[l] < 2 then q1:=301
         else
            if not(md1[l] <> 2) then q1:=302
            else
               if md1[l] > 3 then q1:=304
               else q1:=303;
      if md1[l] < 250 then q1:=400
      else q1:=401;
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed2:=speed2+speed;
   write('.');
   //debug writeln(q1,' ',q2,' ',q3,' ',q4,' ',q5,' ',q6);

   r_ksa_64K(S64K);
   //3 arc4/16 (64K integer S-box) speed
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {3 +, 2 substitution, 3 and operation performed per cycle, obtaining a pr m integer}
      a:=(a+1) and 65535;
      b:=(b+S[a]) and 65535; {actually with fpc1.9.2 this seem to perform a little better than calculating t1 before b and using it instead of S8[0,a]}
      t1:=S[a];
      t2:=S[b];
      S[a]:=t2;
      S[b]:=t1;
      md1[l]:=S[(t1+t2) and 65535];
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed3:=speed3+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md1[a]);

   r_ksa_1M(S1M);
   //4 arc4 (1M integer S-box) speed
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {3 +, 2 substitution, 3 and operation performed per cycle, obtaining a pr m integer}
      a:=(a+1) and 1048575;
      b:=(b+S1M[a]) and 1048575;
      t1:=S[a];
      t2:=S[b];
      S[a]:=t2;
      S[b]:=t1;
      md1[l]:=S1M[(t1+t2) and 1048575];
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed4:=speed4+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md1[a]);

   //5 integer arithmetic and logic
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {integer arithmetic: 1 +, -, *}
      q1:=q4+md1[l];
      q2:=q5-md1[l];
      q3:=q6*md1[l];
      {logic: 1 not, or, xor, shl, shr}
      q1:= not md1[l];
      q2:=q2 and md1[l];
      q3:=q3 or md1[l];
      q4:=q4 xor md1[l];
      q5:=q5 shl md1[l];
      q6:=q6 shr md1[l];
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed5:=speed5+speed;
   write('.');
   //debug writeln(q1,' ',q2,' ',q3,' ',q4,' ',q5,' ',q6);

   //6 slow integer arithmetic
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {slow integer arithmetic: div, mod; 1 if..then}
      if md1[l]=0 then md1[l]:=2;
      q1:=md1[l-1] div md1[l];
      q2:=md1[l+1] mod md1[l];
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed6:=speed6+speed;
   write('.');
   //debug writeln(q1,' ',q2,' ',q3,' ',q4,' ',q5,' ',q6);

   //7 fp arithmetic
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to test_size-1 do
      begin
      {floating point arithmetic: 1 +, -, *}
      rq1:=rq2+md1[l]+0.1234567;
      rq2:=rq2-rq1;
      rq3:=rq2*rq1;
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed7:=speed7+speed;
   write('.');
   //debug writeln(rq1,' ',rq2,' ',rq3);

   //8 slow fp arithmetic
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do
   begin
   for l:=0 to (test_size div 8 -1) do
      begin
      {slow floating point arithmetic: / between fp and int, frac, trunc; if..then}
      rq1:=md1[l]+0.1234567;
      rq3:=trunc(rq1);
      rq3:=round(rq1);
      rq3:=int(rq1);
      rq3:=frac(rq1);
      rq3:=rq3/rq1;
      end;
   end;
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=test_size div 8 div 1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed8:=speed8+speed;
   write('.');
   //debug writeln(rq1,' ',rq2,' ',rq3);

   //9 move 1KB chunks
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do for l:=0 to 1048575 do move (md1,md2,1024);
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed9:=speed9+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md2[a]);

   //10 move 32KB chunks
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do for l:=0 to 32767 do move (md1,md2,32768);
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=1024 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed10:=speed10+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md2[a]);

   //11 move 1MB chunks
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do for l:=0 to 511 do move (md1,md2,1048576);
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=512 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed11:=speed11+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md2[a]);

   //12 move 16MB chunks
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do for l:=0 to 7 do move (md1,md2,16777216);
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=128 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed12:=speed12+speed;
   write('.');
   //debug for a:=0 to 10 do writeln(md2[a]);

   //13 move 64MB chunks
   TS:=DateTimeToTimeStamp(Now);
   time_begin:=TS.time;
   for j:=1 to multi do for l:=0 to 1 do move (md1,md2,67108864);
   TS:=DateTimeToTimeStamp(Now);
   time_end:=TS.time;
   time_elapsed:=time_end-time_begin;
   if time_elapsed > 0 then speed:=128 * 1000 div time_elapsed * multi
   else
      begin
      writeln('Time is 0, cannot calculate the speed.');
      readln;
      halt;
      end;
   speed13:=speed13+speed;
   writeln('.');
   //debug for a:=0 to 10 do writeln(md2[a]);

   end;

//interpretation of results
{in s_overall slow int and slow fp tests are weighted 1/3 than other tests since
slower instructions tend to be avoided or replaced with speedier workaround by
programmers whenever it's possible}
speed1:= speed1 div max_i;
speed2:= speed2 div max_i;
speed3:= speed3 div max_i;
speed4:= speed4 div max_i;
speed5:= speed5 div max_i;
speed6:= speed6 div max_i;
speed7:= speed7 div max_i;
speed8:= speed8 div max_i;
speed9:= speed9 div max_i;
speed10:= speed10 div max_i;
speed11:= speed11 div max_i;
speed12:= speed12 div max_i;
speed13:= speed13 div max_i;
speed1eq:= speed1 * eq1 div 1000;
speed2eq:= speed2 * eq2 div 1000;
speed3eq:= speed3 * eq3 div 1000;
speed4eq:= speed4 * eq4 div 1000;
speed5eq:= speed5 * eq5 div 1000;
speed6eq:= speed6 * eq6 div 1000;
speed7eq:= speed7 * eq7 div 1000;
speed8eq:= speed8 * eq8 div 1000;
speed9eq:= speed9 * eq9 div 1000;
speed10eq:= speed10 * eq10 div 1000;
speed11eq:= speed11 * eq11 div 1000;
speed12eq:= speed12 * eq12 div 1000;
speed13eq:= speed13 * eq13 div 1000;
s_overall:=(3*(speed1eq+speed2eq+speed3eq+speed4eq+speed5eq+speed7eq+speed9eq+speed10eq+speed11eq)+speed6eq+speed8eq) div 29;
c_overall:=(speed1eq+speed3eq+speed4eq+speed9eq+speed10eq+speed11eq) div 6;
m_overall:=(speed4eq+speed11eq+speed12eq+speed13eq) div 4;

//presentation of results
writeln;
writeln('System Profile:');
writeln;
if upcase(auto_mode)='N' then
   begin
   writeln('Small random structure test:  similar to ',processor,' ',speed1eq,' MHz;   ',speed1,' Kcycle/sec');
   writeln('Medium random structure test: similar to ',processor,' ',speed3eq,' MHz;   ',speed3,' Kcycle/sec');
   writeln('Large random structure test:  similar to ',processor,' ',speed4eq,' MHz;   ',speed4,' Kcycle/sec');
   writeln('Int arithmetic/logic test:    similar to ',processor,' ',speed5eq,' MHz;   ',speed5,' Kcycle/sec');
   writeln('Int slow test:                similar to ',processor,' ',speed6eq,' MHz;   ',speed6,' Kcycle/sec');
   writeln('FP arithmetic test:           similar to ',processor,' ',speed7eq,' MHz;   ',speed7,' Kcycle/sec');
   writeln('FP slow test:                 similar to ',processor,' ',speed8eq,' MHz;   ',speed8,' Kcycle/sec');
   writeln('Conditional test:             similar to ',processor,' ',speed2eq,' MHz;   ',speed2,' Kcycle/sec');
   writeln('Move 1KB chunks test:         similar to ',processor,' ',speed9eq,' MHz;   ',speed9,' MB/sec');
   writeln('Move 32KB chunks test:        similar to ',processor,' ',speed10eq,' MHz;   ',speed10,' MB/sec');
   writeln('Move 1MB chunks test:         similar to ',processor,' ',speed11eq,' MHz;   ',speed11,' MB/sec');
   writeln('Move 16MB chunks test:        similar to ',processor,' ',speed12eq,' MHz;   ',speed12,' MB/sec');
   writeln('Move 64MB chunks test:        similar to ',processor,' ',speed13eq,' MHz;   ',speed13,' MB/sec');
   writeln;
   end;
l:=s_overall;
bench_presentation;
writeln('* Speed overall is similar to a system based on ',processor,' ',s_overall,' Mhz');
writeln;
l:=c_overall;
bench_presentation;
writeln('* Cache overall is similar to a system based on ',processor,' ',c_overall,' Mhz');
writeln;
l:=m_overall;
bench_presentation;
writeln('* Memory overall is similar to a system based on ',processor,' ',m_overall,' Mhz');
readln;
end.
